package nc.bs.servlet.service;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.ic.impl.DeleteIcMaterialOutImpl;
import nc.bs.ic.impl.IDeleteIcMaterialOut;
import nc.itf.uap.pf.IPFBusiAction;
import nc.log.NcLog;
import nc.pub.util.DataSourceUtil;
import nc.vo.ic.m4d.entity.MaterialOutHeadVO;
import nc.vo.pub.workflownote.WorkflownoteVO;
import net.sf.json.JSONObject;

public class DeleteIcMaterialOutServlet extends BaseServlet implements IHttpServletAdaptor{

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			//Դ
			DataSourceUtil.setDataSource();
			
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSONObject.fromObject(createStr);
			NcLog.info("json:" + json);
			ISecurityTokenCallback sc = (ISecurityTokenCallback) NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
			sc.token("NCSystem".getBytes(), "pfxx".getBytes());
		
			IDeleteIcMaterialOut iDeleteIcMaterialOut = new DeleteIcMaterialOutImpl();
			iDeleteIcMaterialOut.DeleteIcMaterialOut_RequiresNew(json);
			resp.getWriter().write(formatRSJsonData("0",STATUS_SUCCESS,"ϳⵥɾɹ").toString());			
			
		} catch (Exception e) {
			//ǰ˿̨ӡxml
			resp.getWriter().write(formatRSJsonData("1",STATUS_FAILURE,e.getMessage()).toString());
			StringWriter stringWriter = new StringWriter();
			//e.printStackTrace(new PrintWriter(stringWriter));
			e.printStackTrace();
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ӿڷֵʾ:"+msg);
		}
   }
	

}
