package nc.bs.scmpub.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Arrays;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.test.service.BaseServlet;
import nc.impl.scmf.ic.mbatchcode.BatchcodeMaintainImpl;
import nc.itf.scmf.ic.mbatchcode.IBatchcodeMaintainService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.pub.test.util.DataSourceUtil;
import nc.vo.bd.meta.BatchOperateVO;
import nc.vo.ecpubapp.pattern.exception.ExceptionUtils;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.scmf.ic.mbatchcode.BatchcodeVO;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

//κŵӿ
public class BatchCodeAddImpl extends BaseServlet implements
		IHttpServletAdaptor {

	BaseDAO db = new BaseDAO();
	IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(
			IUAPQueryBS.class.getName());
	String id = "";
	JSONArray arrys;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		// TODO Զɵķ
		arrys = new JSONArray();
		try {
			DataSourceUtil.setDataSource();
		} catch (BusinessException e) {
			// TODO Զɵ catch 
		}
		InvocationInfoProxy.getInstance().setGroupId(this.qryGroup());
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class)
				.token("NCSystem".getBytes(), "pfxx".getBytes());
		String createStr = buildJson(req, resp, this.getClass().getName());
		JSONObject json = JSONObject.fromObject(createStr);
		JSONArray results = json.getJSONArray("results");
		PrintWriter out = resp.getWriter();
		StringBuffer returnstr = new StringBuffer();

		for (int i = 0; i < results.size(); i++) {
			JSONObject obj = (JSONObject) results.get(i);
			id = obj.getString("id");
			String checkresult;
			try {
				checkresult = checkJson(obj);
				if (!(checkresult.equals("") || checkresult.equals(null))) {
					JSONObject jsonobj = new JSONObject();
					jsonobj.put("status", "ʧ");
					jsonobj.put("id", obj.getString("id"));
					jsonobj.put("message", "" + i + "¼" + checkresult + ";");
					arrys.add(jsonobj);
					continue;
				}
			} catch (Exception e) {
				// TODO Զɵ catch 
			}// ǿж
			String code = obj.getString("cmaterialoid");
			String vbatchcode = obj.getString("vbatchcode");
			BatchOperateVO operatevo = new BatchOperateVO();
			BatchcodeVO[] vos = new BatchcodeVO[1];
			BatchcodeVO batchcodevo = new BatchcodeVO();
			batchcodevo.setVbatchcode(vbatchcode);
			String pk_material = "";
			try {
				pk_material = SqlexecuteQuery("pk_material",
						"bd_material", "code", code);
				batchcodevo.setCmaterialoid(pk_material);
			} catch (Exception e) {
				// TODO Զɵ catch 
			}
			try {
				batchcodevo.setCmaterialvid(SqlexecuteQuery("pk_source",
						"bd_material", "code", obj.getString("cmaterialoid")));
			} catch (Exception e) {
				// TODO Զɵ catch 
			}
			batchcodevo.setDinbounddate(new UFDate(obj
					.getString("dinbounddate")));
			batchcodevo.setDproducedate(new UFDate(obj
					.getString("dproducedate")));
			batchcodevo.setDvalidate(new UFDate(obj.getString("dvalidate")));
			batchcodevo.setVdef18(obj.getString("vdef18"));
			batchcodevo.setVdef19(obj.getString("vdef19"));
			batchcodevo.setPk_group(this.qryGroup());
			vos[0] = batchcodevo;
			operatevo.setAddObjs(vos);
			
			//ΨһУ
			String qrysql = "select count(*) from scm_batchcode where cmaterialoid = '"+pk_material+"' and vbatchcode = '"+vbatchcode+"' and dr = 0";
			try {
				List<Object> returnnum =  (List<Object>) iuap.executeQuery(qrysql,new ColumnListProcessor());
				if(!returnnum.get(0).toString().equals("0")){
					JSONObject jsonobj = new JSONObject();
					jsonobj.put("status", "ʧ");
					jsonobj.put("id", obj.getString("id"));
					jsonobj.put("message", ""+code+"κ"+vbatchcode+"ظ!,ܱ档");
					arrys.add(jsonobj);
					continue;
				}
			} catch (BusinessException e1) {
				// TODO Զɵ catch 
				e1.printStackTrace();
			}
			BatchcodeMaintainImpl impl = new BatchcodeMaintainImpl();
			try {
				impl.batchSave(operatevo);
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				
				JSONObject jsonobj = new JSONObject();
				jsonobj.put("status", "ʧ");
				jsonobj.put("id", id);
				jsonobj.put("message", e.getMessage());
				arrys.add(jsonobj);
				continue;
			}
			
			JSONObject jsonobj = new JSONObject();
			jsonobj.put("status", "ɹ");
			jsonobj.put("id", obj.getString("id"));
			jsonobj.put("message", "" + i + "¼ɹκΪ" + vbatchcode + ";");
			arrys.add(jsonobj);
		}

		resp.getWriter().write(arrys.toString());
		return;
	}

	/*
	 * ǿж
	 */
	private String checkJson(JSONObject json) throws Exception {

		StringBuffer mags = new StringBuffer();
		Boolean empty = true;

		String vbatchcode = "vbatchcode";// κ
		String cmaterialoid = "cmaterialoid";// ϱ
		String dinbounddate = "dinbounddate";// ״
		String dproducedate = "dproducedate";// 
		String dvalidate = "dvalidate";// ʧЧ
		String vdef18 = "vdef18";//
		String vdef19 = "vdef19";//

		String[] HeadKey = { vbatchcode, cmaterialoid, dinbounddate,
				dproducedate, dvalidate ,vdef18 ,vdef19};

		for (String as : HeadKey) {

			if (json.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}

		if (!empty) {
			return "ֶβΪգ" + mags;
		}
		return "";
	}

	/**
	 * ݿѯ
	 * 
	 * @param out
	 * @param table
	 * @param key
	 * @param value
	 * @return
	 * @throws Exception
	 */
	private String SqlexecuteQuery(String out, String table, String key,
			String value) throws Exception {

		String sql = "select " + out + " from " + table + " where " + key
				+ " = '" + value
				+ "' and nvl(dr,0)=0 and enablestate = '2' and latest = 'Y'";

		Object object;
		try {
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object == null) {
				throw new Exception("δѯݣ" + value + "Ƿȷ");
			}

			return object.toString();
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			ExceptionUtils.wrappBusinessException(e.getMessage());
			return e.getMessage();
		}
	}

	/**
	 * ȡid
	 * 
	 * @return
	 */
	private String qryGroup() {
		String qrysql = "select pk_group from org_group where nvl(dr,0)=0 and rownum = 1";
		String pk_group;
		try {
			pk_group = (String) iuap
					.executeQuery(qrysql, new ColumnProcessor());
			return pk_group;
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
}
