package nc.pubimpl.so.m4331.pfxx;

import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillConcurrentTool;
import nc.impl.so.m4331.action.maintain.DeliveryInsertAction;
import nc.impl.so.m4331.action.maintain.DeliveryUpdateAction;
import nc.itf.uap.pf.IPFBusiAction;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.ecpubapp.pattern.exception.ExceptionUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.so.m4331.entity.DeliveryBVO;
import nc.vo.so.m4331.entity.DeliveryHVO;
import nc.vo.so.m4331.entity.DeliveryVO;

/**
 * <b> ڴ˴ҪĹ </b>
 * 
 * <p>
 * ڴ˴ӴϢ
 * </p>
 * 
 * @author ufsoft
 * @version Your Project V60
 */
public class M4331PfxxPlugin extends nc.pubimpl.so.pfxx.AbstractSOPfxxPlugin {
  @Override
  protected AggregatedValueObject insert(AggregatedValueObject vo) {
    DeliveryVO[] insertvo = new DeliveryVO[] {
      (DeliveryVO) vo
    };
    /**
     * ԴĿıѯָڵĻ
     * 
     * @param src_currency_pk
     *            Դ
     * @param dest_currency_pk
     *            ĿıֵΪnullʱΪĬĿı
     * @param date
     * @return
     * @throws BusinessException
     */
    DeliveryVO newvo = insertvo[0];
    DeliveryHVO headvo = newvo.getParentVO();
    CurrencyRateUtil currRateUtil = CurrencyRateUtil
				.getInstanceByOrg(headvo.getPk_org());
    DeliveryBVO[] bodyvos = newvo.getChildrenVO();
    for(DeliveryBVO bodyvo:bodyvos){
    	String corigcurrencyid = bodyvo.getCorigcurrencyid();//ԭ
    	String ccurrencyid= bodyvo.getCcurrencyid();//λ
    	try {
			if(corigcurrencyid.equals(ccurrencyid)){
					UFDouble nnum = bodyvo.getNnum();//
					UFDouble nastnum = bodyvo.getNastnum();//
					UFDouble vchangerate = nastnum.div(nnum);//λ
					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
					UFDouble norigtaxprice = vchangerate.multiply(nqtorigtaxprice);//˰
					UFDouble norigprice = vchangerate.multiply(nqtorigprice);//˰
					bodyvo.setNqtunitnum(nnum);//
					bodyvo.setVqtunitrate("1.00000000/1.00000000");//ۻ
					bodyvo.setNqtorigtaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNqtorigprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNqtorignetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorigtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorigprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorigtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorignetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNcaltaxmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorigmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNorigtaxmny(norigtaxmny.setScale(2, UFDouble.ROUND_HALF_UP));//˰ϼ
					bodyvo.setNqttaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
					bodyvo.setNqtprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNqttaxnetprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
					bodyvo.setNqtnetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
					bodyvo.setNprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
					bodyvo.setNnetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
					bodyvo.setNtaxmny(nastnum.multiply(nqtorigtaxprice).setScale(2, UFDouble.ROUND_HALF_UP));//Ҽ˰ϼ
					//˰
					bodyvo.setNtax(bodyvo.getNtaxmny().sub(bodyvo.getNmny()));//˰
					
					continue;
				}
				else{

 					UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,/*ԭ*/
 	 	 					ccurrencyid/**/, headvo.getDbilldate());//
 	 				bodyvo.setNexchangerate(foreignrate);//۱
 	 				UFDouble nnum = bodyvo.getNnum();//
 					UFDouble nastnum = bodyvo.getNastnum();//
 					UFDouble vchangerate = nastnum.div(nnum);//λ
 					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
 					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
 					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
 					UFDouble norigtaxprice = vchangerate.multiply(nqtorigtaxprice);//˰
 					UFDouble norigprice = vchangerate.multiply(nqtorigprice);//˰
 					UFDouble nqtprice =	currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, nqtorigprice, foreignrate, headvo.getDbilldate());//˰
 					UFDouble nqttaxprice =	currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, nqtorigtaxprice, foreignrate, headvo.getDbilldate());//Һ˰
 					UFDouble ntaxprice = currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, norigtaxprice, foreignrate, headvo.getDbilldate());//Һ˰
 					UFDouble nprice = currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());//˰
 					bodyvo.setNqtunitnum(nnum);//
 					bodyvo.setVqtunitrate("1.00000000/1.00000000");//ۻ
 					bodyvo.setNqtorigtaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorignetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorignetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNcaltaxmny(nastnum.multiply(nqtprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxmny(norigtaxmny.setScale(2, UFDouble.ROUND_HALF_UP));//˰ϼ
 					bodyvo.setNqttaxprice(nqttaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtprice(nqtprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqttaxnetprice(nqttaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtnetprice(nqtprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxprice(ntaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNprice(nprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxnetprice(ntaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNnetprice(nprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNmny(nastnum.multiply(nqtprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxmny(nastnum.multiply(nqttaxprice).setScale(2, UFDouble.ROUND_HALF_UP));//Ҽ˰ϼ
 					//˰
 					bodyvo.setNtax(bodyvo.getNtaxmny().sub(bodyvo.getNmny()));//˰
 				
				}
				
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
	}
    
    
   /* DeliveryInsertAction insert = new DeliveryInsertAction();
    try {
		DeliveryVO[] ret = insert.insert(insertvo);
		if (null == ret || ret.length == 0) {
		  return null;
		}
		IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
		DeliveryVO[] approvevos = (DeliveryVO[]) service.processAction("APPROVE", "4331", null, ret[0], null, null);
		return approvevos[0];
	} catch (Exception e) {
		// TODO Զɵ catch 
		e.printStackTrace();
		ExceptionUtils.wrappBusinessException(e.getMessage());
		
	}
	return insertvo[0];*/
    
    DeliveryInsertAction insert = new DeliveryInsertAction();
    DeliveryVO[] ret = insert.insert(insertvo);
	if (null == ret || ret.length == 0) {
	  return null;
	}
	return ret[0];
    
  }

  @Override
  protected AggregatedValueObject update(AggregatedValueObject vo, String vopk) {
    DeliveryVO[] updatevo = new DeliveryVO[] {
      (DeliveryVO) vo
    };
    BillQuery<DeliveryVO> billquery =
        new BillQuery<DeliveryVO>(DeliveryVO.class);
    DeliveryVO[] origvos = billquery.query(new String[] {
      vopk
    });
    BillConcurrentTool tool = new BillConcurrentTool();
    tool.lockBill(origvos);
    DeliveryUpdateAction update = new DeliveryUpdateAction();
    DeliveryVO[] retvos = update.update(updatevo, origvos);
    if (null == retvos || retvos.length == 0) {
      return null;
    }
    return retvos[0];
  }
}
